Gecode::Int::Count::EqInt< VX, VY > Class Template Reference
Other available functionality » Integer propagators

Propagator for counting views (equal integer to number of equal views) More...

`#include <count.hh>`

## Public Member Functions

virtual Actor * | copy (Space &home)
| Create copy during cloning.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)
| Perform propagation.
Public Member Functions inherited from Gecode::Int::Count::IntBase< VX, VY >
virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low linear).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
virtual | ~Actor (void)
| To avoid warnings.

## Static Public Member Functions

static ExecStatus | post (Home home, ViewArray< VX > &x, VY y, int c)
| Post propagator for .
static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Protected Member Functions

| EqInt (Space &home, EqInt &p)
| Constructor for cloning p.
| EqInt (Home home, ViewArray< VX > &x, int n_s, VY y, int c)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Int::Count::IntBase< VX, VY >
| IntBase (Space &home, IntBase &p)
| Constructor for cloning p.
| IntBase (Home home, ViewArray< VX > &x, int n_s, VY y, int c)
| Constructor for creation.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Additional Inherited Members

Protected Attributes inherited from Gecode::Int::Count::IntBase< VX, VY >
ViewArray< VX > | x
| Views still to count.
int | n_s
| Views from x[0] ... x[n_s-1] have subscriptions.
VY | y
| View to compare to.
int | c
| Number of views which are equal and have been eliminated.

## Detailed Description

template<class VX, class VY>
class Gecode::Int::Count::EqInt< VX, VY >

Propagator for counting views (equal integer to number of equal views)

Not all combinations of views are possible. The types VX and VY must be either equal, or VY must be ConstIntView, ZeroIntView, or IntSet.

Requires

#include <gecode/int/count.hh>
count.hh

Definition at line 172 of file count.hh.

## Constructor & Destructor Documentation

## EqInt() [1/2]

template<class VX, class VY>

Gecode::Int::Count::EqInt< VX, VY >::EqInt | ( | Space & | home,
|  | EqInt< VX, VY > & | p )

inline protected

Constructor for cloning p.

Definition at line 76 of file int-eq.hpp.

## EqInt() [2/2]

template<class VX, class VY>

Gecode::Int::Count::EqInt< VX, VY >::EqInt | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | int | n_s,
|  | VY | y,
|  | int | c )

inline protected

Constructor for creation.

Definition at line 38 of file int-eq.hpp.

## Member Function Documentation

## copy()

template<class VX, class VY>

Actor * Gecode::Int::Count::EqInt< VX, VY >::copy | ( | Space & | home | ) |

virtual

Create copy during cloning.

Implements Gecode::Actor.

Definition at line 81 of file int-eq.hpp.

## propagate()

template<class VX, class VY>

ExecStatus Gecode::Int::Count::EqInt< VX, VY >::propagate | ( | Space & | home,
|  | const ModEventDelta & | med )

virtual

Perform propagation.

Implements Gecode::Propagator.

Definition at line 87 of file int-eq.hpp.

## post()

template<class VX, class VY>

ExecStatus Gecode::Int::Count::EqInt< VX, VY >::post | ( | Home | home,
|  | ViewArray< VX > & | x,
|  | VY | y,
|  | int | c )

static

Post propagator for .

Definition at line 43 of file int-eq.hpp.

The documentation for this class was generated from the following files:

- gecode/int/count.hh
- gecode/int/count/int-eq.hpp